/* Copyright (C) 2007 Christian Dywan <christian at twotoasts dot de>

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA. */

#ifndef __BROWSER_H__
#define __BROWSER_H__ 1

#include "ui.h"
#include "helpers.h"
#include "document.h"
#include "debug.h"

#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <libsexy/sexy-icon-entry.h>

// -- Declarations

void on_action_window_new_activate(GtkAction*, CBrowser*);

void on_action_tab_new_activate(GtkAction*, CBrowser*);

void on_action_open_activate(GtkAction*, CBrowser*);

void on_action_tab_close_activate(GtkAction*, CBrowser*);

void on_action_window_close_activate(GtkAction*, CBrowser*);

void on_action_quit_activate(GtkAction*, CBrowser*);

void on_action_find_activate(GtkAction*, CBrowser*);

void on_action_find_next_activate(GtkAction*, CBrowser*);

void on_action_find_previous_activate(GtkAction*, CBrowser*);

void on_action_preferences_activate(GtkAction*, CBrowser*);

void on_action_toolbar_navigation_activate(GtkToggleAction*, CBrowser*);

void on_action_toolbar_bookmarks_activate(GtkToggleAction*, CBrowser*);

void on_action_panels_activate(GtkToggleAction*, CBrowser*);

void on_action_toolbar_status_activate(GtkToggleAction*, CBrowser*);

void on_action_refresh_stop_activate(GtkAction*, CBrowser*);

void on_action_zoom_in_activate(GtkAction*, CBrowser*);

void on_action_zoom_out_activate(GtkAction*, CBrowser*);

void on_action_zoom_normal_activate(GtkAction*, CBrowser*);

void on_action_back_activate(GtkAction*, CBrowser*);

void on_action_forward_activate(GtkAction*, CBrowser*);

void on_action_home_activate(GtkAction*, CBrowser*);

void on_action_location_activate(GtkAction*, CBrowser*);

void on_action_websearch_activate(GtkAction*, CBrowser*);

void on_action_openinpanel_activate(GtkAction*, CBrowser*);

void on_menu_tabsclosed_item_activate(GtkMenuItem*, CBrowser*);

void on_action_tabsclosed_clear_activate(GtkAction*, CBrowser*);

void on_action_tabclosed_undo_activate(GtkAction*, CBrowser*);

void on_action_link_tab_new_activate(GtkAction*, CBrowser*);

void on_action_link_tab_current_activate(GtkAction*, CBrowser*);

void on_action_link_window_new_activate(GtkAction*, CBrowser*);

void on_action_link_savewith_activate(GtkAction*, CBrowser*);

void on_action_link_copy_activate(GtkAction*, CBrowser*);

void on_action_colorpicker_activate(GtkAction*, CBrowser*);

void on_action_tab_previous_activate(GtkAction*, CBrowser*);

void on_action_tab_next_activate(GtkAction*, CBrowser*);

void on_action_about_activate(GtkAction*, CBrowser*);

CBrowser* browser_new(CBrowser*);

// -- Action definitions

// TODO: Fill in a good description for each 'hm?'
// TODO: We need more mnemonics
static const GtkActionEntry entries[] = {
 { "File", NULL, "_File" },
 { "WindowNew", STOCK_WINDOW_NEW
 , NULL, "<Ctrl>n"
 , "Open a new window", G_CALLBACK(on_action_window_new_activate) },
 { "TabNew", STOCK_TAB_NEW
 , NULL, "<Ctrl>t"
 , "Open a new tab", G_CALLBACK(on_action_tab_new_activate) },
 { "Open", GTK_STOCK_OPEN
 , NULL, "<Ctrl>o"
 , "Open a file", G_CALLBACK(on_action_open_activate) },
 { "SaveAs", GTK_STOCK_SAVE_AS
 , NULL, "<Ctrl>s"
 , "Save to a file", NULL/*G_CALLBACK(on_action_saveas_activate)*/ },
 { "TabClose", STOCK_TAB_CLOSE
 , NULL, "<Ctrl>w"
 , "Close the current tab", G_CALLBACK(on_action_tab_close_activate) },
 { "WindowClose", STOCK_WINDOW_CLOSE
 , NULL, "<Ctrl><Shift>w"
 , "Close this window", G_CALLBACK(on_action_window_close_activate) },
 { "PageSetup", GTK_STOCK_PROPERTIES
 , "Page setup", ""
 , "hm?", NULL/*G_CALLBACK(on_action_page_setup_activate)*/ },
 { "PrintPreview", GTK_STOCK_PRINT_PREVIEW
 , NULL, ""
 , "hm?", NULL/*G_CALLBACK(on_action_print_preview_activate)*/ },
 { "Print", GTK_STOCK_PRINT
 , NULL, "<Ctrl>p"
 , "hm?", NULL/*G_CALLBACK(on_action_print_activate)*/ },
 { "Quit", GTK_STOCK_QUIT
 , NULL, "<Ctrl>q"
 , "Quit the application", G_CALLBACK(on_action_quit_activate) },

 { "Edit", NULL, "_Edit" },
 { "Undo", GTK_STOCK_UNDO
 , NULL, "<Ctrl>z"
 , "Undo the last modification", NULL/*G_CALLBACK(on_action_undo_activate)*/ },
 { "Redo", GTK_STOCK_REDO
 , NULL, "<Ctrl><Shift>z"
 , "Redo the last modification", NULL/*G_CALLBACK(on_action_redo_activate)*/ },
 { "Cut", GTK_STOCK_CUT
 , NULL, "<Ctrl>x"
 , "Cut the selected text", NULL/*G_CALLBACK(on_action_cut_activate)*/ },
 { "Copy", GTK_STOCK_COPY
 , NULL, "<Ctrl>c"
 , "Copy the selected text", NULL/*G_CALLBACK(on_action_copy_activate)*/ },
 { "Paste", GTK_STOCK_PASTE
 , NULL, "<Ctrl>v"
 , "Paste text from the clipboard", NULL/*G_CALLBACK(on_action_paste_activate)*/ },
 { "Delete", GTK_STOCK_DELETE
 , NULL, "Delete"
 , "Delete the selected text", NULL/*G_CALLBACK(on_action_delete_activate)*/ },
 { "SelectAll", GTK_STOCK_SELECT_ALL
 , NULL, "<Ctrl>a"
 , "Selected all text", NULL/*G_CALLBACK(on_action_selectall_activate)*/ },
 { "FormFill", STOCK_FORM_FILL
 , NULL, ""
 , "hm?", NULL/*G_CALLBACK(on_action_formfill_activate)*/ },
 { "Find", GTK_STOCK_FIND
 , NULL, "<Ctrl>f"
 , "hm?", G_CALLBACK(on_action_find_activate) },
 { "FindNext", GTK_STOCK_GO_FORWARD
 , "Find next", "<Ctrl>g"
 , "hm?", G_CALLBACK(on_action_find_next_activate) },
 { "FindPrevious", GTK_STOCK_GO_BACK
 , "Find previous", "<Ctrl><Shift>g"
 , "hm?", G_CALLBACK(on_action_find_previous_activate) },
 { "FindQuick", GTK_STOCK_FIND
 , "Quick find", "period"
 , "hm?", NULL/*G_CALLBACK(on_action_find_quick_activate)*/ },
 { "Preferences", GTK_STOCK_PREFERENCES
 , NULL, ""
 , "hm?", G_CALLBACK(on_action_preferences_activate) },

 { "View", NULL, "_View" },
 { "Refresh", GTK_STOCK_REFRESH
 , NULL, "<Ctrl>r"
 , "Refresh the current page", G_CALLBACK(on_action_refresh_stop_activate) },
 // TODO: Is appointment-new a good choice?
 // TODO: What if it isn't available?
 { "RefreshEvery", "appointment-new"
 , "Refresh every...", ""
 , "Refresh the current page", G_CALLBACK(on_action_refresh_stop_activate) },
 { "Stop", GTK_STOCK_STOP
 , NULL, "Escape"
 , "Stop loading of the current page", G_CALLBACK(on_action_refresh_stop_activate) },
 { "RefreshStop", GTK_STOCK_REFRESH
 , NULL, ""
 , NULL, G_CALLBACK(on_action_refresh_stop_activate) },
 { "ZoomIn", GTK_STOCK_ZOOM_IN
 , NULL, "<Ctrl>plus"
 , "hm?", G_CALLBACK(on_action_zoom_in_activate) },
 { "ZoomOut", GTK_STOCK_ZOOM_OUT
 , NULL, "<Ctrl>minus"
 , "hm?", G_CALLBACK(on_action_zoom_out_activate) },
 { "ZoomNormal", GTK_STOCK_ZOOM_100
 , NULL, "<Ctrl>0"
 , "hm?", G_CALLBACK(on_action_zoom_normal_activate) },
 { "BackgroundImage", STOCK_IMAGE
 , "Background image", ""
 , "hm?", NULL/*G_CALLBACK(on_action_background_image_activate)*/ },
 { "SourceView", STOCK_SOURCE_VIEW
 , NULL, ""
 , "hm?", NULL/*G_CALLBACK(on_action_source_view_activate)*/ },
 { "SelectionSourceView", STOCK_SOURCE_VIEW
 , "View selection source", ""
 , "hm?", NULL/*G_CALLBACK(on_action_selection_source_view_activate)*/ },
 { "Properties", GTK_STOCK_PROPERTIES
 , NULL, ""
 , "hm?", NULL/*G_CALLBACK(on_action_properties_activate)*/ },

 { "Go", NULL, "_Go" },
 { "Back", GTK_STOCK_GO_BACK
 , NULL, "<Alt>Left"
 , "hm?", G_CALLBACK(on_action_back_activate) },
 { "Forward", GTK_STOCK_GO_FORWARD
 , NULL, "<Alt>Right"
 , "hm?", G_CALLBACK(on_action_forward_activate) },
 { "Home", STOCK_HOMEPAGE
 , NULL, "<Alt>Home"
 , "hm?", G_CALLBACK(on_action_home_activate) },
 { "Location", GTK_STOCK_JUMP_TO
 , "Location...", "<Ctrl>l"
 , "hm?", G_CALLBACK(on_action_location_activate) },
 { "Websearch", GTK_STOCK_FIND
 , "Websearch...", "<Ctrl><Shift>f"
 , "hm?", G_CALLBACK(on_action_websearch_activate) },
 { "OpenInPageholder", GTK_STOCK_JUMP_TO
 , "Open in page_holder...", ""
 , "hm?", G_CALLBACK(on_action_openinpanel_activate) },
 { "TabsClosed", STOCK_USER_TRASH
 , "Closed tabs", ""
 , "hm?", NULL },
 { "TabsClosedClear", GTK_STOCK_CLEAR
 , "Clear list of closed tabs", ""
 , "hm?", G_CALLBACK(on_action_tabsclosed_clear_activate) },
 { "UndoTabClose", GTK_STOCK_UNDELETE
 , "Undo close tab", ""
 , "hm?", G_CALLBACK(on_action_tabclosed_undo_activate) },
 { "LinkTabNew", STOCK_TAB_NEW
 , "Open link in new tab", ""
 , "hm?", G_CALLBACK(on_action_link_tab_new_activate) },
 { "LinkTabCurrent", NULL
 , "Open link in current tab", ""
 , "hm?", G_CALLBACK(on_action_link_tab_current_activate) },
 { "LinkWindowNew", STOCK_WINDOW_NEW
 , "Open link in new window", ""
 , "hm?", G_CALLBACK(on_action_link_window_new_activate) },
 { "LinkBookmarkNew", STOCK_BOOKMARK_NEW
 , NULL, ""
 , "Bookmark this link", NULL/*G_CALLBACK(on_action_link_bookmark_activate)*/ },
 { "LinkSaveAs", GTK_STOCK_SAVE
 , "Save destination as...", ""
 , "Save destination to a file", NULL/*G_CALLBACK(on_action_link_saveas_activate)*/ },
 { "LinkSaveWith", STOCK_DOWNLOADS
 , "Download destination", ""
 , "Save destination with the chosen download manager", G_CALLBACK(on_action_link_savewith_activate) },
 { "LinkCopy", GTK_STOCK_COPY
 , "Copy link address", ""
 , "Copy the link address to the clipboard", G_CALLBACK(on_action_link_copy_activate) },
 { "SelectionLinksNewTabs", NULL
 , "Open selected links in tabs", ""
 , "hm?", NULL/*G_CALLBACK(on_action_properties_selection_activate)*/ },
 { "SelectionTextTabNew", STOCK_TAB_NEW
 , "Open <selection> in new tab", ""
 , "hm?", NULL/*G_CALLBACK(on_action_properties_selection_activate)*/ },
 { "SelectionTextTabCurrent", NULL
 , "Open <selection> in current tab", ""
 , "hm?", NULL/*G_CALLBACK(on_action_properties_selection_activate)*/ },
 { "SelectionTextWindowNew", STOCK_WINDOW_NEW
 , "Open <selection> in new window", ""
 , "hm?", NULL/*G_CALLBACK(on_action_properties_selection_activate)*/ },
 { "SelectionSearch", GTK_STOCK_FIND
 , "Search for <selection>", ""
 , "hm?", NULL/*G_CALLBACK(on_action_properties_selection_activate)*/ },
 { "SelectionSearchWith", GTK_STOCK_FIND
 , "Search for <selection> with...", ""
 , "hm?", NULL/*G_CALLBACK(on_action_properties_selection_activate)*/ },
 { "ImageViewTabNew", STOCK_TAB_NEW
 , "View image in new tab", ""
 , "hm?", NULL/*G_CALLBACK(on_action_properties_selection_activate)*/ },
 { "ImageViewTabCurrent", NULL
 , "View image in current tab", ""
 , "hm?", NULL/*G_CALLBACK(on_action_properties_selection_activate)*/ },
 { "ImageSaveAs", GTK_STOCK_SAVE
 , "Save image as...", ""
 , "Save image to a file", NULL/*G_CALLBACK(on_action_properties_selection_activate)*/ },
 { "ImageSaveWith", STOCK_DOWNLOADS
 , "Download image", ""
 , "Save image with the chosen download manager", NULL/*G_CALLBACK(on_action_properties_selection_activate)*/ },
 { "ImageCopy", GTK_STOCK_COPY
 , "Copy image address", ""
 , "Copy the image address to the clipboard", NULL/*G_CALLBACK(on_action_properties_selection_activate)*/ },

 { "Bookmarks", NULL, "_Bookmarks" },
 { "BookmarkNew", STOCK_BOOKMARK_NEW
 , NULL, "<Ctrl>d"
 , "hm?", NULL/*G_CALLBACK(on_action_bookmark_new_activate)*/ },
 { "BookmarksManage", STOCK_BOOKMARKS
 , "_Manage bookmarks", "<Ctrl>b"
 , "hm?", NULL/*G_CALLBACK(on_action_bookmarks_manage_activate)*/ },

 { "Tools", NULL, "_Tools" },
 { "ColorPicker", GTK_STOCK_COLOR_PICKER
 , "_Color picker", ""
 , "hm?", G_CALLBACK(on_action_colorpicker_activate) },

 { "Window", NULL, "_Window" },
 { "SessionLoad", NULL
 , "Load session", ""
 , "hm?", NULL/*G_CALLBACK(on_action_session_load_activate)*/ },
 { "SessionSave", NULL
 , "Save session", ""
 , "hm?", NULL/*G_CALLBACK(on_action_session_save_activate)*/ },
 { "TabPrevious", NULL
 , "Previous tab", "<Ctrl>Page_Up"
 , "hm?", G_CALLBACK(on_action_tab_previous_activate) },
 { "TabNext", NULL
 , "Next tab", "<Ctrl>Page_Down"
 , "hm?", G_CALLBACK(on_action_tab_next_activate) },
 { "TabOverview", NULL
 , "Tab overview", ""
 , "hm?", NULL/*G_CALLBACK(on_action_tab_overview_activate)*/ },

 { "Help", NULL, "_Help" },
 { "HelpContents", GTK_STOCK_HELP
 , "_Contents", "F1"
 , "hm?", NULL/*G_CALLBACK(on_action_help_contents_activate)*/ },
 { "About", GTK_STOCK_ABOUT
 , NULL, ""
 , "hm?", G_CALLBACK(on_action_about_activate) },
 };
 static const guint entries_n = G_N_ELEMENTS(entries);

static const GtkToggleActionEntry toggle_entries[] = {
 { "PrivateBrowsing", NULL
 , "Private browsing", ""
 , "hm?", NULL/*G_CALLBACK(on_action_private_browsing_activate)*/
 , FALSE },
 { "WorkOffline", GTK_STOCK_DISCONNECT
 , "Work offline", ""
 , "hm?", NULL/*G_CALLBACK(on_action_work_offline_activate)*/
 , FALSE },

 { "ToolbarNavigation", NULL
 , "Navigationbar", ""
 , "hm?", G_CALLBACK(on_action_toolbar_navigation_activate)
 , FALSE },
 { "Panels", NULL
 , "_Panels", "F9"
 , "hm?", G_CALLBACK(on_action_panels_activate)
 , FALSE },
 { "ToolbarBookmarks", NULL
 , "Bookmarkbar", ""
 , "hm?", G_CALLBACK(on_action_toolbar_bookmarks_activate)
 , FALSE },
 { "ToolbarDownloads", NULL
 , "Downloadbar", ""
 , "hm?", NULL/*G_CALLBACK(on_action_toolbar_downloads_activate)*/
 , FALSE },
 { "ToolbarStatus", NULL
 , "Statusbar", ""
 , "hm?", G_CALLBACK(on_action_toolbar_status_activate)
 , FALSE },
 { "RefreshEveryEnable", NULL
 , "Enabled", ""
 , "hm?", NULL/*G_CALLBACK(on_action_reloadevery_enable_activate)*/
 , FALSE },
 { "ReloadEveryActive", NULL
 , "_Active", ""
 , "hm?", NULL/*G_CALLBACK(on_action_reloadevery_active_activate)*/
 , FALSE },
 };
 static const guint toggle_entries_n = G_N_ELEMENTS(toggle_entries);

static const GtkRadioActionEntry refreshevery_entries[] = {
 { "RefreshEvery30", NULL
 , "30 seconds", ""
 , "Refresh every 30 seconds", 30 },
 { "RefreshEvery60", NULL
 , "60 seconds", ""
 , "Refresh every 60 seconds", 60 },
 { "RefreshEvery300", NULL
 , "5 minutes", ""
 , "Refresh every 5 minutes", 300 },
 { "RefreshEvery900", NULL
 , "15 minutes", ""
 , "Refresh every 15 minutes", 900 },
 { "RefreshEvery1800", NULL
 , "30 minutes", ""
 , "Refresh every 30 minutes", 1800 },
 { "RefreshEveryCustom", NULL
 , "Custom...", ""
 , "Refresh by a custom period", 0 },
 };
 static const guint refreshevery_entries_n = G_N_ELEMENTS(refreshevery_entries);

static const GtkRadioActionEntry panel_entries[] = {
 { "PanelDownloads", STOCK_DOWNLOADS
 , NULL, ""
 , "hm?", 0 },
 { "PanelBookmarks", STOCK_BOOKMARKS
 , "_Bookmarks", ""
 , "hm?", 1 },
 { "PanelConsole", STOCK_CONSOLE
 , NULL, ""
 , "hm?", 2 },
 { "PanelExtensions", STOCK_EXTENSIONS
 , NULL, ""
 , "hm?", 3 },
 { "PanelHistory", STOCK_HISTORY
 , "_History", ""
 , "hm?", 4 },
 // TODO: We want another icon here, but which one?
 { "PanelTabs", STOCK_TAB_NEW
 , "_Tabs", ""
 , "hm?", 5 },
 // TODO: We probably want another icon here
 { "PanelPageholder", GTK_STOCK_CONVERT
 , "Page_holder", ""
 , "hm?", 6 },
 };
 static const guint panel_entries_n = G_N_ELEMENTS(panel_entries);

#endif /* !__BROWSER_H__ */
